package com.googlecode.mad.mvntools.settingsutil.filestore;

import java.io.File;
import java.util.TreeMap;

import com.googlecode.mad.mvntools.settingsutil.utils.FileUtil;

/**
 * Mojo to back up the Files in a x.xml-file
 * 
 * @goal backup
 * 
 */
public class BackupFilestore extends AbstractFilestore {
	
	public BackupFilestore() {
		super();
		name = "SettingsUtil:backup";
	}
	
	@SuppressWarnings("unchecked")
	protected void myExecute() {
		
		TreeMap<String, TreeMap<String, String>> myMap = new TreeMap<String, TreeMap<String, String>>();
		
		String temp = null;
		
		temp = FileUtil.getInstance().loadFile(this.getRootPath() + this.backupFile);
		
		if (temp != null && temp.length() > 0) {
			try {
				myMap = (TreeMap<String, TreeMap<String, String>>) this.xstream.fromXML(temp);
			} catch (Exception e) {
				this.getLog().debug("unmarshaling not possible");
			}
		}
		
		TreeMap<String, String> files = myMap.get(this.user);
		if (files == null) {
			files = new TreeMap<String, String>();
		}
		
		for (String string : this.files) {
			files.put(FILE + string, FileUtil.getInstance().loadFile(this.getRootPath() + string));
		}
		
		for (String string : this.folders) {
			
			File folder = new File(this.getRootPath() + string);
			if (folder.exists() && folder.isDirectory()) {
				String[] ff = folder.list();
				for (String theFile : ff) {
					files.put(FOLDER + string + "/" + theFile, FileUtil.getInstance().loadFile(this.getRootPath() + string + "/" + theFile));
				}
			}
			
		}
		
		myMap.put(this.user, files);
		
		FileUtil.getInstance().recreateFileWithNewContent(this.getRootPath() + this.backupFile, this.xstream.toXML(myMap));
		
	}
}
