package com.googlecode.mad.mvntools.settingsutil.filestore;

import java.io.File;
import java.util.TreeMap;

import com.googlecode.mad.mvntools.settingsutil.utils.FileUtil;

/**
 * Mojo to back up the Files in a x.xml-file
 * 
 * @goal restore
 * 
 */
public class RestoreFilestore extends AbstractFilestore {
	
	public RestoreFilestore() {
		super();
		name = "SettingsUtil:restore";
	}
	
	@SuppressWarnings("unchecked")
	protected void myExecute() {
		
		TreeMap<String, TreeMap<String, String>> myMap = null;
		
		String temp = null;
		
		temp = FileUtil.getInstance().loadFile(this.getRootPath() + this.backupFile);
		
		if (temp != null && temp.length() > 0) {
			try {
				myMap = (TreeMap<String, TreeMap<String, String>>) this.xstream.fromXML(temp);
			} catch (Exception e) {
				this.getLog().debug("unmarshaling not possible");
			}
		}
		
		TreeMap<String, String> files = myMap.get(this.user);
		if (files == null) {
			files = new TreeMap<String, String>();
		}
		
		for (String string : files.keySet()) {
			if (string.startsWith(FILE)) {
				FileUtil.getInstance().recreateFileWithNewContent(string.replace(FILE, ""), files.get(string));
			}
		}
		
		boolean folderok = false;
		for (String string : files.keySet()) {
			if (string.startsWith(FOLDER)) {
				
				if (!folderok) {
					String ftemp = string.replace(FOLDER, "");
					String folderOnly = ftemp.substring(0, ftemp.indexOf("/"));
					File folder = new File(this.getRootPath() + folderOnly);
					if (!folder.exists()) {
						folder.mkdir();
						folderok = true;
					}
				}
				
				System.out.println(string);
				FileUtil.getInstance().recreateFileWithNewContent(string.replace(FOLDER, ""), files.get(string));
			}
		}
	}
}
